//! Errors for this crate
use std::num::TryFromIntError;

/// Error
#[derive(Debug, thiserror::Error)]
pub enum Error {
    /// Internal database error
    #[error("RocksDB: {0}")]
    RocksDb(#[from] rocksdb::Error),

    /// Serialization error
    #[error("Serde: {0}")]
    Serde(#[from] serde_json::Error),

    /// Internal error while converting types to integer
    #[error("Internal error: {0}")]
    Internal(#[from] TryFromIntError),

    /// Transaction error
    #[error("Tx: {0}")]
    Tx(String),

    /// Internal error
    #[error("Unknown family column")]
    InvalidColumnFamily,
}
